#include "../src/AnalysisServiceInterface.hh"
#include <ipc/object.h>
#include "Sct/SctNames.h"
#include "Sct/Exception.h"
#include <string>

int main(int argc, char**argv){
    Sct::setExceptionHandlers(argv[0]);
    using namespace std;
    using Sct::SctNames;  
    
    cout << "AnalysisService test:"<<endl;
    //AnalysisServiceIStatus status;
    
    cout <<"... looking in partition ..."<<SctNames::getPartitionName()<<ends;
    IPCPartition& p = SctNames::getPartition();
    
    cout <<" ... getting a handle ..."<<ends;
    AnalysisServiceI::AnalysisServiceInterface_var handle = 
	p.lookup<AnalysisServiceI::AnalysisServiceInterface>(AnalysisServiceI::AnalysisServiceInterface::instanceName/*, AnalysisServiceI_T_AnalysisServiceInterface::ILUClassRecord*/);
    
    if (CORBA::is_nil(handle)){ cerr<<"Error: handle==0"<<endl; return -1;}
    
    cout <<"Got Handle..."<<endl;
    
    if (argc==1){
	cout << handle->status();
    }

    if (argc==2){
	handle->analyze(argv[1]);
    }
    if (argc==3){
	handle->analyzeModule(argv[1], argv[2]);
    }
    return 0;
}
