#include "TestLibraryImpl.h"
#include "scripts/ResponseCurve.h"
#include "scripts/ThreePointGainTest.h"
#include "scripts/StrobeDelayTest.h"
#include "scripts/NoiseOccupancyTest.h"
#include "scripts/DoubleTriggerNoiseTest.h"
#include "scripts/SynchTriggerNoiseTest.h"
#include "scripts/PipelineTest.h"
#include "scripts/TrimRangeTest.h"
#include "scripts/QuickTrimTest.h"
#include "scripts/FullBypassBarrelTest.h"
#include "scripts/FullBypassEndcapTest.h"
#include "scripts/TimeWalkTest.h"
#include "scripts/NMaskTest.h"
#include "scripts/RxDelayTest.h"
#include "scripts/RxThresholdTest.h"
#include "scripts/RxThresholdBasedOnConfigRegisterTest.h"

namespace SctCalibrationController {
    
using namespace Scripts;

TestLibraryImpl::TestLibraryImpl() {
    cout << "create TestLibraryImpl" << endl;
}

Sct_CalibrationController::TestLibrary_ptr TestLibraryImpl::instance() {
    static TestLibraryImpl* instance = new TestLibraryImpl();
    return instance->_this();
}

Sct_CalibrationController::TestRequest_ptr TestLibraryImpl::responseCurve() {
    return ResponseCurve::instance();
}

Sct_CalibrationController::TestRequest_ptr TestLibraryImpl::threePointGain () {
    return ThreePointGainTest::instance();
}

Sct_CalibrationController::TestRequest_ptr TestLibraryImpl::strobeDelay () {
    return StrobeDelayTest::instance();
}

Sct_CalibrationController::TestRequest_ptr TestLibraryImpl::pipeline () {
    return PipelineTest::instance();
}

Sct_CalibrationController::TestRequest_ptr TestLibraryImpl::noiseOccupancy () {
    return NoiseOccupancyTest::instance();
}
Sct_CalibrationController::TestRequest_ptr TestLibraryImpl::timeWalk () {
    return TimeWalkTest::instance();
}

Sct_CalibrationController::TestRequest_ptr TestLibraryImpl::fullBypassBarrel () {
    return FullBypassBarrelTest::instance();
}

Sct_CalibrationController::TestRequest_ptr TestLibraryImpl::fullBypassEndcap () {
    return FullBypassEndcapTest::instance();
}

Sct_CalibrationController::TestRequest_ptr TestLibraryImpl::trimRange () {
    return TrimRangeTest::instance();
}

Sct_CalibrationController::TestRequest_ptr TestLibraryImpl::quickTrim () {
    return QuickTrimTest::instance();
}

Sct_CalibrationController::TestRequest_ptr TestLibraryImpl::nmask () {
    return NMaskTest::instance();
}

Sct_CalibrationController::TestRequest_ptr TestLibraryImpl::doubleTriggerNoise () {
    return DoubleTriggerNoiseTest::instance();
}

Sct_CalibrationController::TestRequest_ptr TestLibraryImpl::synchTriggerNoise () {
    return SynchTriggerNoiseTest::instance();
}

Sct_CalibrationController::TestRequest_ptr TestLibraryImpl::rxDelay() {
    return RxDelayTest::instance();
}

Sct_CalibrationController::TestRequest_ptr TestLibraryImpl::rxThreshold () {
    return RxThresholdTest::instance();
}

Sct_CalibrationController::TestRequest_ptr TestLibraryImpl::rxThresholdBasedOnConfigRegister () {
    return RxThresholdBasedOnConfigRegisterTest::instance();
}

}
