#ifndef TESTLIBRARYIMPL_H
#define TESTLIBRARYIMPL_H

#include "ipc/TestLibrary.h"
#include <boost/utility.hpp>
#include <ipc/object.h>

namespace SctCalibrationController {
using namespace Ipc;
    
class TestLibraryImpl : public TestLibrary {
public:
    static Sct_CalibrationController::TestLibrary_ptr instance();
    virtual Sct_CalibrationController::TestRequest_ptr responseCurve();
    virtual Sct_CalibrationController::TestRequest_ptr threePointGain();
    virtual Sct_CalibrationController::TestRequest_ptr strobeDelay();    
    virtual Sct_CalibrationController::TestRequest_ptr noiseOccupancy();
    virtual Sct_CalibrationController::TestRequest_ptr pipeline();
    virtual Sct_CalibrationController::TestRequest_ptr fullBypassBarrel();
    virtual Sct_CalibrationController::TestRequest_ptr fullBypassEndcap();
    virtual Sct_CalibrationController::TestRequest_ptr trimRange();
    virtual Sct_CalibrationController::TestRequest_ptr quickTrim();
    virtual Sct_CalibrationController::TestRequest_ptr timeWalk();
    virtual Sct_CalibrationController::TestRequest_ptr nmask();
    virtual Sct_CalibrationController::TestRequest_ptr doubleTriggerNoise();
    virtual Sct_CalibrationController::TestRequest_ptr synchTriggerNoise();

    virtual Sct_CalibrationController::TestRequest_ptr rxDelay();
    virtual Sct_CalibrationController::TestRequest_ptr rxThreshold();
    virtual Sct_CalibrationController::TestRequest_ptr rxThresholdBasedOnConfigRegister();
private:
    TestLibraryImpl();
};
    
}

#endif //TESTLIBRARYIMPL_H
