#ifndef IPC_CALIBRATIONCONTROLLER_H
#define IPC_CALIBRATIONCONTROLLER_H

#include "CalibrationController.hh"
#include <ipc/object.h>
#include <memory>
#include <vector>
#include <boost/shared_ptr.hpp>

using namespace std;
using boost::shared_ptr;

namespace SctCalibrationController {
namespace Ipc {

class ScanRequest;
class ScanLibrary;   
class TestLibrary;
class SequenceLibrary;
class TestSequence;
class TestRequest;
class SequenceRequest;	

/**
   Maps ILU-IPC requests onto the nicer pure virtual interface. 
*/

class CalibrationController : public IPCNamedObject<POA_Sct_CalibrationController::CalibrationController, ipc::multi_thread> {
public:
  /*
  // Corba interface part ..............
  
    Sct_CalibrationController::ScanLibrary_ptr getScanLibrary_corba ();
    Sct_CalibrationController::TestLibrary_ptr getTestLibrary_corba ();
    Sct_CalibrationController::SequenceLibrary_ptr getSequenceLibrary_corba ();
    void doScan_corba (Sct_CalibrationController::ScanRequest_ptr s);
    void doTest_corba (Sct_CalibrationController::TestRequest_ptr t);
    void doSequence_corba (Sct_CalibrationController::SequenceRequest_ptr r);
    void abort_corba ();
    void setUpdateOption_corba(Sct_CalibrationController::CalibrationController::UpdateOption opt);
    Sct_SctApi::Scan_ptr getScan_corba(CORBA::ULong runNumber, CORBA::ULong scanNumber);
    virtual void updateWith_corba(const char* testResultInIs, bool force);
    
    // Pretty interface part ...................

    virtual ScanLibrary& getScanLibrary_nonCorba() const = 0;
    virtual TestLibrary& getTestLibrary_nonCorba() const = 0;
    virtual SequenceLibrary& getSequenceLibrary_nonCorba() const = 0;
    virtual void doScan_nonCorba (shared_ptr<ScanRequest> s) = 0;
    virtual void doTest_nonCorba (shared_ptr<TestRequest> t) = 0;
    virtual void doSequence_nonCorba(shared_ptr<SequenceRequest> r) = 0;
    virtual void abort_nonCorba() = 0;
    virtual Sct_SctApi::Scan* getScan_nonCorba(unsigned long runNumber, unsigned long scanNumber) const = 0;
    virtual void setUpdateOption_nonCorba(Sct_CalibrationController::CalibrationController::UpdateOption opt) =0;
    virtual void updateWith_nonCorba (const char * testResultInIs, bool force)=0;
*/
protected:
    CalibrationController();
    virtual ~CalibrationController();
};
}
}
#endif //#ifndef CALIBRATIONCONTROLLER_H
