#include "../src/ipc/CalibrationController.hh"

#include <ipc/object.h>
#include <ipc/server.h>
#include <ipc/partition.h>
#include <ipc/core.h>
#include <ctime>
#include <cstdlib>
#include <cstring>
//#include <ilu/iluxport.h>
#include "Sct/OmniMarshalling.h"
#include "Sct/BugReport.h"

using namespace std;


class TestSequenceRequest : public IPCObject<POA_Sct_CalibrationController::SequenceRequest> {
public:
    TestSequenceRequest(Sct_CalibrationController::CalibrationController_ptr cc) {
	this->cc = Sct_CalibrationController::CalibrationController::_duplicate(cc);
	
	//Sct_CalibrationControllerStatus status;
	//ilu_DebugPrintf("%s", "\n\nAbout to call getTestLibrary\n\n");
	std::cerr << "\n\nAbout to call getTestLibrary\n\n" << std::flush;
	Sct_CalibrationController::TestLibrary_ptr tl = cc->getTestLibrary(/*&status*/);
	responseCurve = tl->responseCurve(/*&status*/);	
    }
    
  virtual char * startSequence (/*Sct_CalibrationControllerStatus *_status, */ /*Sct_CalibrationController::CalibrationController_ptr cc,*/ Sct_SctApi::SctApiIPC_ptr api) {
	cout << "startSequence" << endl;
        Sct::BugReport("BUG01", "TestCalibrationController.cpp","IS IT THIS ONE? startSequence");
	cout << "CalibrationController: " << cc << endl;
	//this->cc = cc;
	this->api = Sct_SctApi::SctApiIPC::_duplicate(api);
	char* name = ::Sct::copyStringToCorba("TestSequenceRequest");
	//this->cc->incRef();
	cout << "startSequence finished" << endl;
	return name;
    }
    
    virtual Sct_CalibrationController::TestRequest_ptr getNextTest (/*Sct_CalibrationControllerStatus *_status, */CORBA::ULong index) {	
	cout << "getNextTest " << index << endl;
	//cout << "CalibrationController: " << cc << endl;
	
	//ilu_DebugPrintf("%s", "\n\nAbout to call getTestLibrary\n\n");
	//Sct_CalibrationController_T_TestLibrary* tl = cc->getTestLibrary(&status);
	//cout << "TestLibrary: " << tl << "  " << status.returnCode << endl;
	switch (index) {
	case 0:
	    return Sct_CalibrationController::TestRequest::_duplicate(responseCurve);//tl->responseCurve(&status);
	default:
	    cout << "Return 0" << endl;
	    return Sct_CalibrationController::TestRequest::_nil();
	}	
    }
    
    virtual CORBA::Boolean applyConfigChanges (/*Sct_CalibrationControllerStatus *_status,*/CORBA::ULong index) {
	cout << "applyConfigChanges " << index << endl;	
	return false;
    }
    
  virtual void endSequence (/*Sct_CalibrationControllerStatus *_status*/) {
	cc = Sct_CalibrationController::CalibrationController::_nil();
	api = Sct_SctApi::SctApiIPC::_nil();
	cout << "endSequence" << endl;
	this->_destroy();;
    }
    

private:
  Sct_CalibrationController::CalibrationController_var cc;
  Sct_SctApi::SctApiIPC_var api;
  Sct_CalibrationController::TestRequest_var responseCurve;
};

void testRequest(void* server) {
    IPCPartition p("SCT");
    Sct_CalibrationController::CalibrationController_var cc = p.lookup<Sct_CalibrationController::CalibrationController>(Sct_CalibrationController::CalibrationController::instanceName);
    cout << "Got handle? " << cc << endl;
    
    TestSequenceRequest* tsr = new TestSequenceRequest(cc);    
    
    //Sct_CalibrationControllerStatus status;
    //status.returnCode = 0;

    //ilu_DebugPrintf("%s", "\n\n\n\nAbout to call doSequence\n\n");	
    std::cerr << "\n\n\n\nAbout to call doSequence\n\n" << std::flush;	
    Sct_CalibrationController::SequenceRequest_var impl = tsr->_this();
    cc->doSequence(/*&status, */impl);
    cout << "doSequence? " << /*status.returnCode <<*/ endl;
}

int main(int argc, char** argv) {
    IPCCore::init(argc,argv);
#warning What should this line become?    ilu_SetDebugLevelViaString("MOST");
#warning What should this line become?    ilu_SendDebugOutputToFile("TestCalibrationControllerILU.out");

    IPCPartition p("SCT");
    {
    Sct_CalibrationController::CalibrationController_var cc = p.lookup<Sct_CalibrationController::CalibrationController>(Sct_CalibrationController::CalibrationController::instanceName);

    cout << "Got handle? " << cc << endl;
    //Sct_CalibrationControllerStatus status;
    //status.returnCode = 0;
    
    //IPCObjectVar<Sct_CalibrationController_T_SequenceLibrary> lib = cc->getSequenceLibrary(&status);
    //cout << "Got library? " <<  status.returnCode << "   " << lib << endl;
    //IPCObjectVar<Sct_CalibrationController_T_SequenceRequest> req = lib->characterizationSequence(&status);
    //cout << "Got request? " << status.returnCode << "   " << req << endl;
    //time_t start = time(0);
    //cc->doSequence(&status, req);
    //cout << "TestSequence requested " << status.returnCode << endl;
    //time_t now = time(0);
    //cout << difftime(now, start) << " seconds to return" << endl;
    //cc->doSequence(&status, cc->getSequenceLibrary(&status)->characterizationSequence(&status));
    cout << "SequenceLibrary: " << cc->getSequenceLibrary(/*&status*/) << "  " /*<< status.returnCode*/ << endl;
    cout << "TestLibrary: " << cc->getTestLibrary(/*&status*/) << "  " << /*status.returnCode << */endl;
    cout << "ScanLibrary: " << cc->getScanLibrary(/*&status*/) << "  " << /*status.returnCode << */endl;
    }
    //cout << "Did that work?? " << status.returnCode << endl;
    
    
    //Now try the request:
    IPCServer server;
#warning Not sure what to do with this line ... probably not important...    server.doSoon(testRequest, &server);
    server.run();
    cout << "Finished" << endl;
}
