#include "../service/FitterInterface.hh"
#include <ipc/core.h>
#include <ipc/object.h>
#include "Sct/SctNames.h"
#include "Sct/Exception.h"
#include <string>

int main(int argc, char**argv){
    IPCCore::init(argc,argv);
    Sct::setExceptionHandlers(argv[0]);
    using namespace std;
    using Sct::SctNames;  
    
    cout << "FittingService test:"<<endl;
    // LESTER: Delete this: FitterIStatus status;
    
    cout <<"... looking in partition ..."<<SctNames::getPartitionName()<<ends;
    IPCPartition& p = SctNames::getPartition();
    
    cout <<" ... getting a handle ..."<<ends;
    FitterI::FitterInterface_var handle =  
      p.lookup<FitterI::FitterInterface>(FitterI::FitterInterface::instanceName);
    
    if (CORBA::is_nil(handle)){ cerr<<"Error: handle==0"<<endl; return -1;}
    
    cout <<"Got Handle..."<<endl;
    
    if (argc>1){
      handle->setFitStrategy(argv[1]);
    }
    if (argc>2){
	handle->setFitOptions(argv[2]);
    }

    boost::shared_ptr<char> theStatus = boost::shared_ptr<char>(handle->status());
    cout <<"Status is:"<<theStatus <<endl;
    
    boost::shared_ptr<char> theStrategy=boost::shared_ptr<char>(handle->getFitStrategy());
    cout <<"strategy is: "<<theStrategy <<endl;
    
    boost::shared_ptr<char> theOptions=boost::shared_ptr<char>(handle->getFitOptions());
    cout <<"options are: "<<theOptions <<endl;
    
    cout <<handle->nFitsDone()<<" fits done with "<<handle->nFitErrors()<<" errors"<<endl;
    return 0;
}
