#include <boost/test/unit_test.hpp>
#include <ipc/core.h>
#include "Env_Test.h"
#include "Name_Test.h"
#include "OmniMarshalling_Test.h"

using boost::unit_test_framework::test_suite;
using namespace Sct;

test_suite* init_unit_test_suite(int argc, char * argv[]) {
  IPCCore::init(argc, argv);
    std::auto_ptr<test_suite> test(BOOST_TEST_SUITE("Test package Sct"));

    test->add(new Env_Test());
    test->add(new Name_Test());
    test->add(new OmniMarshalling_Test());
    return test.release();
}


