#ifndef SCTDATA_IO_DOUBLETRIGGERNOISETESTRESULTSTREAMER_V2_H
#define SCTDATA_IO_DOUBLETRIGGERNOISETESTRESULTSTREAMER_V2_H

#include "TestResultStreamer_v1.h"

namespace SctData {
namespace IO {

/**
 * This class allows publishing and refreshing of DoubleTriggerNoiseTestResult objects to and from IS.
 */
class DoubleTriggerNoiseTestResultStreamer_v2 : public Sct::Streamer {
public:
    //Streamer_v1 overrides
    virtual void write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);
    virtual shared_ptr<Streamable> read(IStream& in, const IOManager& manager) const throw(LogicError, IoError);
    virtual void read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);   
     virtual unsigned getVersion() const throw() {return s_version;}
     
private:
    DoubleTriggerNoiseTestResultStreamer_v2() throw();		///< Constructor is private
   static unsigned s_version;
   static bool inMap;					///< The static dummy variable for the IOManager map
};
}
}
#endif // #ifndef SCTDATA_IO_DOUBLETRIGGERNOISETESTRESULTSTREAMER_V2_H
