#include "RxThresholdBasedOnConfigRegisterTestResultStreamer_v1.h"

using namespace Sct;

namespace SctData {
    namespace IO {

/* READ NOTES ON STREAMERS AND VERSIONS BEFORE EDITING THIS FILE! */
unsigned RxThresholdBasedOnConfigRegisterTestResultStreamer_v1::s_version=1;

	RxThresholdBasedOnConfigRegisterTestResultStreamer_v1::RxThresholdBasedOnConfigRegisterTestResultStreamer_v1() throw() {}
	
bool RxThresholdBasedOnConfigRegisterTestResultStreamer_v1::inMap = IOManager::addToMap("SctData::RxThresholdBasedOnConfigRegisterTestResult",  auto_ptr<Streamer>(new RxThresholdBasedOnConfigRegisterTestResultStreamer_v1()));
	
	shared_ptr<Streamable> RxThresholdBasedOnConfigRegisterTestResultStreamer_v1::read(IStream& in, const IOManager& manager) const throw(LogicError, IoError){
	    boost::shared_ptr<Streamable> ad (new RxThresholdBasedOnConfigRegisterTestResult());
	    read(in, *ad, manager);
	    return ad;
	}
	
	void RxThresholdBasedOnConfigRegisterTestResultStreamer_v1::write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
	    //Let superclass do its work
	    manager.writeImpl(out, ob, "SctData::TestResult");
	    
	    //cout << "RxThresholdBasedOnConfigRegisterTestResultStreamer_v1 doing dynamic_cast" << endl;
	    const RxThresholdBasedOnConfigRegisterTestResult& mytest = dynamic_cast<const RxThresholdBasedOnConfigRegisterTestResult&>(ob);
	    
	    for (unsigned int iStream=0; iStream<nLinkModule; iStream++) {
		writeStreamResult(out, mytest.getStreamResult(iStream), manager);
	    }
	}
	
	void RxThresholdBasedOnConfigRegisterTestResultStreamer_v1::read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
	    manager.readImpl(in, ob, "SctData::TestResult");
	    
	    RxThresholdBasedOnConfigRegisterTestResult& mytest = dynamic_cast<RxThresholdBasedOnConfigRegisterTestResult&>(ob);
	    
	    for (unsigned int iStream=0; iStream<nLinkModule; iStream++) {
		readStreamResult(in, mytest.getStreamResult(iStream), manager);
	    }
	}
	
	void RxThresholdBasedOnConfigRegisterTestResultStreamer_v1::writeStreamResult(OStream& out, const RxThresholdBasedOnConfigRegisterTestResult::StreamResult& c, const IOManager& manager) const throw (LogicError, IoError) {
          out << c.minErrorFreeRxThresh() 
              << c.maxErrorFreeRxThresh()
              << c.bestRxThresh();
	}
	
	void RxThresholdBasedOnConfigRegisterTestResultStreamer_v1::readStreamResult(IStream& in, RxThresholdBasedOnConfigRegisterTestResult::StreamResult& c, const IOManager& manager) const throw(LogicError, IoError) {
          typedef RxThresholdBasedOnConfigRegisterTestResult::StreamResult::ThresholdType ThresholdType;
          ThresholdType minTmp,maxTmp,bestTmp;
          in >> minTmp >> maxTmp >> bestTmp;
          c.setMinErrorFreeRxThresh(minTmp);
          c.setMaxErrorFreeRxThresh(maxTmp);
          c.setBestRxThresh(bestTmp);
	}
	
    } 
}
