#ifndef SCTDATA_IO_SINGLEVARIABLETESTRESULTSTREAMER_V2_H
#define SCTDATA_IO_SINGLEVARIABLETESTRESULTSTREAMER_V2_H

#include "TestResultStreamer_v1.h"

namespace SctData {
namespace IO {

/**
 * This class allows publishing and refreshing of SingleVariableTestResult objects to and from IS.
 * The published and refreshed elements are:
 * -> The fraction of the distance from the leading edge to the 
 * falling edge with which the optima were found.
 * -> the (usually 12 - 1 per chip) opimum values found by the analysis.
 */
class SingleVariableTestResultStreamer_v2 : public Sct::Streamer {
public:
    //Streamer_v1 overrides
    virtual void write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);
    virtual shared_ptr<Streamable> read(IStream& in, const IOManager& manager) const throw(LogicError, IoError);
    virtual void read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);   
     virtual unsigned getVersion() const throw() {return s_version;}
     
private:
    SingleVariableTestResultStreamer_v2() throw();		///< Constructor is private
   static unsigned s_version;
   static bool inMap;					///< The static dummy variable for the IOManager map
};
}
}
#endif // #ifndef SCTDATA_IO_SINGLEVARIABLETESTRESULTSTREAMER_V2_H
