#ifndef STROBEDELAYTESTRESULT_H
#define STROBEDELAYTESTRESULT_H

#include "SingleVariableTestResult.h"

using namespace std;

namespace SctData {
	
  /**
   * A derived class of TestResult, containing the results data for a Strobe Delay Test.
   * Such a test requires only a single scan.<P>
   * The result of the analysis is an optimum delay value for each of the 12 chips.
   * @author Alan Barr
   */
class StrobeDelayTestResult : public SingleVariableTestResult {
public:
    StrobeDelayTestResult() throw();
    ~StrobeDelayTestResult() throw() {}
    /**
    Constructor.  
    */
    StrobeDelayTestResult(const unsigned int runNumber, const string& moduleName) throw() ;
    /** impliment here */
    virtual string getClassName() const throw();
};
  
} // end of namespace SctData

#endif //#ifndef STROBEDELAYTESTRESULT_H
