
#ifndef SCTAPIIPC_CONVERTER_H
#define SCTAPIIPC_CONVERTER_H

namespace SctApiIPC {

  class Converter {
  public:
    static ::SctApi::Scan::ScanOptionsEnum corbaToScanOptionsEnum(const Sct_SctApi::Scan::ScanOptions opt) {
      switch (opt) {
      case Sct_SctApi::Scan::full:
	return ::SctApi::Scan::FULL;
      case Sct_SctApi::Scan::bits32:
	return ::SctApi::Scan::BITS32;
      case Sct_SctApi::Scan::loopCalLine:
	return ::SctApi::Scan::LOOPCALLINE;
      case Sct_SctApi::Scan::distSlave:
	return ::SctApi::Scan::DISTSLAVE;
      case Sct_SctApi::Scan::debug:
	return ::SctApi::Scan::DEBUG;
      case Sct_SctApi::Scan::tim:
        return ::SctApi::Scan::TIM;
      case Sct_SctApi::Scan::nth:
        return ::SctApi::Scan::NTH;
      case Sct_SctApi::Scan::nth_rem:
        return ::SctApi::Scan::NTH_REM;
      case Sct_SctApi::Scan::enableDataMode:
        return ::SctApi::Scan::ENABLE_DATA_MODE;
      default:
	throw Sct_SctApi::SctApiException("Unknown Sct_SctApi::Scan::ScanOptions opt");
      };
    };
    static Sct_SctApi::Scan::ScanOptions scanOptionsEnumToCorba(const ::SctApi::Scan::ScanOptionsEnum opt) {
      switch (opt) {
      case ::SctApi::Scan::FULL:
	return Sct_SctApi::Scan::full;
      case ::SctApi::Scan::BITS32:
	return Sct_SctApi::Scan::bits32;
      case ::SctApi::Scan::LOOPCALLINE:
	return Sct_SctApi::Scan::loopCalLine;
      case ::SctApi::Scan::DISTSLAVE:
	return Sct_SctApi::Scan::distSlave;
      case ::SctApi::Scan::DEBUG:
	return Sct_SctApi::Scan::debug;
      case ::SctApi::Scan::TIM:
	return Sct_SctApi::Scan::tim;
      case ::SctApi::Scan::NTH:
	return Sct_SctApi::Scan::nth;
      case ::SctApi::Scan::NTH_REM:
	return Sct_SctApi::Scan::nth_rem;
      case ::SctApi::Scan::ENABLE_DATA_MODE:
        return Sct_SctApi::Scan::enableDataMode;
    default:
      throw Sct_SctApi::SctApiException("Unknown ::SctApi::Scan::ScanOptionsEnum opt");
      };
    };
  };

};

#endif 
