#This is an example setup script for both building from source and running the
#binary release.  

###############################
#Required variables for running
###############################

# The following line may be useful for debugging OKS queries themselves, but it will break many command that grep in to output of these queries :(
#setenv OKS_KERNEL_SILENCE no

###### External Software ######

#AJB
#setenv GCCDIR  /usr/local/gcc/bin
setenv GCCDIR /usr/local/gcc-alt-3.2.2
#setenv GCCDIR /usr/local/gcc-alt-3.2.3
setenv PATH ${GCCDIR}/bin:${PATH}

#Change this if you use gcc295
setenv CMTCONFIG i686-rh73-gcc32-dbg

# Initialise the online software
setenv TDAQ_JAVA_HOME /usr/java/j2sdk1.4.1_02 #Or set JAVA_HOME instead
setenv PATH ${TDAQ_JAVA_HOME}/bin:${PATH}
#source /usr/local/atlas/tdaq/cmt/online-00-21-02/installed/setup.csh
#source /sct1/daqsoft/online-00-21-02/installed/setup.csh
source /sct1/daqsoft/online-00-22-00/installed/setup.csh
setenv PYTHONPATH ${TDAQ_INST_PATH}/${CMTCONFIG}/lib

#Fix online software for version 2.96 - only necessary if you insist on using unsupported compilers!
#test `gcc -dumpversion` = "2.96" && setenv LD_LIBRARY_PATH `echo -n $LD_LIBRARY_PATH | tr ':' "\012" | grep -e external -v | tr "\012" ":"`

#Setup the DataFlow software
#setenv LD_LIBRARY_PATH ${LD_LIBRARY_PATH}:${HOME}/usr/local/lib

#setenv DF_INST_PATH /usr/local/atlas/tdaq/DataFlow/DF-00-04-02/installed
#setenv DF_INST_PATH /usr/local/atlas/tdaq/DataFlow/DF-00-09-01/installed
#setenv DF_INST_PATH /sct1/daqsoft/DF-00-09-01/installed
setenv DF_INST_PATH /sct1/daqsoft/DF-00-10-00/installed
setenv PATH ${DF_INST_PATH}/${CMTCONFIG}/bin:${DF_INST_PATH}/share/bin:${PATH}
setenv LD_LIBRARY_PATH ${LD_LIBRARY_PATH}:${DF_INST_PATH}/${CMTCONFIG}/lib

# Setup the PVSS libraries - may not be necessary
#setenv PVSS_PATH /usr/local/atlas/tdaq/dcs/pvss2_v2.12
#setenv PVSS_PATH /usr/local/atlas/tdaq/dcs/pvss2_v3.0 
setenv PVSS_PATH /sct1/dcssoft/pvss2_v3.0

# MOVED BELOW DEFN OF SCT_DAQ_ROOT ...
setenv PATH ${PATH}:${PVSS_PATH}/bin

#Setup ROOT
#AJB setenv ROOTSYS /usr/local/atlas/root
#setenv ROOTSYS /usr/local/atlas/root32 
setenv ROOTSYS /usr/local/shared/root
setenv PATH ${ROOTSYS}/bin:${PATH}
setenv LD_LIBRARY_PATH ${LD_LIBRARY_PATH}:${ROOTSYS}/lib


######## Our Software #########

# The following should set SCT_DAQ_ROOT to the directory this script is run from
setenv SCT_DAQ_ROOT /sct1/daqsoft/SctRodDaq_4.xx_onl-22-00
#setenv CLASSPATH ${CLASSPATH}:${HOME}/extras/ext/junit3.8.1/junit.jar
setenv CLASSPATH ${CLASSPATH}:/sct1/daqsoft/junit3.8.1/junit.jar

#Set this to your rod configuration (or nothing for the test setup)
#setenv SCTDAQ_ROD_CONFIGURATION_PATH ${SCT_DAQ_ROOT}/installed/config/TestConfig/DefaultRod.xml
setenv SCTDAQ_ROD_CONFIGURATION_PATH /sct1/sctConf/sct_sr1/rods/revE.xml

setenv TDAQ_DB_DATA ${SCT_DAQ_ROOT}/installed/config/databases/SCT.data.xml

#Only necessary if you share your online software installation
setenv TDAQ_IPC_INIT_REF file:${SCT_DAQ_ROOT}/ipc.ref.file

# Directory to put IS proxy files
setenv SCT_SCRATCH_DIR /sct1/scratch

setenv SCT_PERSISTENT_DIR  /sct2/sr1_data


################################
#Required variables for building
################################
# Point to external programs 
setenv BOOSTDIR /sct1/daqsoft/boost-1.30.2
#setenv NAGDIR /home/gallop/src/Nag_C/
setenv MYSQLHDR /usr/include/mysql
setenv MYSQLPPHDR /usr/include
# Point to external java jar files
setenv SCT_DAQ_EXT  /sct1/daqsoft/ext
setenv LD_LIBRARY_PATH ${LD_LIBRARY_PATH}:${HOME}/usr/local/lib

setenv LD_LIBRARY_PATH ${GCCDIR}/lib:${LD_LIBRARY_PATH}

#####################################
#And finally, source the setup script
#####################################
setenv PATH ${HOME}/bin:${PATH}

cd ${SCT_DAQ_ROOT}
source ./setup.csh
