/*
 * BookKeeperPrompt.java
 *
 * Created on 26 March 2004, 12:10
 */

package DisplayGUI;
import java.io.*;

/**
 *
 * @author  robinson
 */
public class BookKeeperPrompt extends javax.swing.JFrame implements displayParams {

    File file=null;
    
    /** Creates new form JFrame */
    public BookKeeperPrompt() {
        super("SctRodDaq BookKeeper");
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        getContentPane().setBackground(backgroundColor);

        jLabel1 = new javax.swing.JLabel();
        jTextArea1 = new javax.swing.JTextArea();
        jLabel2 = new javax.swing.JLabel();
        enterButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jLabel1.setText("jLabel1");
        jLabel1.setFont(displayTextFont);
        jLabel1.setForeground(darkBlueColor);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        getContentPane().add(jLabel1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jTextArea1.setLineWrap(true);
        jTextArea1.setWrapStyleWord(true);
        javax.swing.JScrollPane areaScrollPane = new javax.swing.JScrollPane(jTextArea1);
        areaScrollPane.setVerticalScrollBarPolicy(
                        javax.swing.JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
        areaScrollPane.setPreferredSize(new java.awt.Dimension(250, 250));
        getContentPane().add(areaScrollPane, gridBagConstraints);

        jLabel2.setText("Enter comments");
        jLabel2.setFont(displayScaleFont);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTHWEST;
        getContentPane().add(jLabel2, gridBagConstraints);

        enterButton.setText("Enter");
        enterButton.setFont(displayScaleFont);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTHWEST;
        getContentPane().add(enterButton, gridBagConstraints);
        enterButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
              if(file==null) {
                 System.err.println("Null test index file");
                 return;
                 }
              try {
                BufferedWriter out = new BufferedWriter(new FileWriter(file));
                String txt = jTextArea1.getText();
                if(!txt.equals("")) out.write(jTextArea1.getText());
                out.close();
              }catch(Exception e) {
                System.err.println("SctGUI::BookKeeper - failed to update test index file "+file.getAbsolutePath()+" - "+e.toString());
                }
            exitForm(null);
            }
        });

        closeButton.setText("Close");
        closeButton.setFont(displayScaleFont);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTHEAST;
        getContentPane().add(closeButton, gridBagConstraints);
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitForm(null);
            }
        });

        pack();
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        java.awt.Dimension WSize = getSize();
        setLocation((screenSize.width-(int)WSize.getWidth())/2,(screenSize.height-(int)WSize.getHeight())/2);
    }
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {
        setVisible(false);
    }

    public void showPrompt(File file, String run, String scan, String testName) {
        this.file=file;

        File parent = file.getParentFile();
        if(!parent.exists()) {
           javax.swing.JOptionPane.showMessageDialog(null,"Bookkeeping not available for this run or scan");
           return;
           }

        if(testName==null) {
            jLabel1.setText("Run "+run);
            jLabel2.setText("Please enter a description for this run:");
            }
        else {
            jLabel1.setText(testName+" (Run/Scan "+run+"/"+scan+")");
            jLabel2.setText("Please enter a description for this test:");
            }
        jTextArea1.setText("");
        try {
        if(file.exists()) {
            BufferedReader in = new BufferedReader(new FileReader(file));
            String line;
            int count=0;
            while((line=in.readLine())!=null) {
               if(count>0) jTextArea1.append("\n");
               jTextArea1.append(line);
               count++;
               }
            in.close();
            }
         }catch(Exception e) {
            System.err.println("SctGUI::BookKeeper - Failed to read test index "+file.getAbsolutePath()+" - "+e.toString());
            }
         pack();
         setVisible(true);
        }
              
    

    
    // Variables declaration - do not modify
    private javax.swing.JButton closeButton;
    private javax.swing.JButton enterButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JTextArea jTextArea1;
    // End of variables declaration
    
}
