package webscripts;
// getDBfiles.java
// @Author Dave Robinson
//
// 21052003 Introduce controlFlag - bit 1 set means create upload files but don't upload
//                                  bit 2 set means don't show gui and immediately create upload files


import java.io.*;
import java.util.*;
import java.sql.*;
import ProdDatabase.*;
import ProdDatabase.SCTDBInfo;

public class generalScripts {



public static Vector getPositionMap(int i) throws Exception {

       Vector list = new Vector();
       StringBuffer sqlStat = new StringBuffer("SELECT ser_no,posn FROM assm_items WHERE");
       sqlStat.append(" assm_ser_no="+DisplayGUI.SCTInfo.SCTSerialNumbers[i]);
       sqlStat.append(" ORDER BY ser_no");

//      System.out.println(sqlStat.toString());
       Statement statement = SCTDBInterface.getInstance().connection.createStatement();
       ResultSet resultSet = statement.executeQuery(sqlStat.toString());
       int recordCount=0;

       for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
          String sn = resultSet.getString(1);
          String posn = resultSet.getString(2);
          DisplayGUI.SCTDBAssemblyInfo a = new DisplayGUI.SCTDBAssemblyInfo(posn);
	  list.addElement(sn+"="+DisplayGUI.SCTInfo.SCTViewNames[i]+", Row "+a.getRow()+", Position "+a.getPos());
          }
       statement.close();
       return list;
       }

       
public static void makeDataReferenceFile(String targetDir, int testIndex, boolean isWarm) throws Exception {

       Set s = new HashSet();
       StringBuffer sqlStat = new StringBuffer("SELECT tests.ser_no,tests.TEST_no,tests.locn_name,tests.test_date");
       for(int y=0;y<SCTDBInfo.chipDBnames.length;y++) sqlStat.append(","+SCTDBInfo.chipDBnames[y]+"RC_MN_ENC,"+SCTDBInfo.chipDBnames[y]+"RC_MN_GAIN");
       sqlStat.append(" FROM "+SCTDBInfo.sctdaqDBTableNames[testIndex]+",tests,sct_tstdcsinfo,SCT_TSTDAQINFO");
       sqlStat.append(" WHERE tests.TEST_name = '"+SCTDBInfo.sctdaqDBTestNames[testIndex]+"'");
       sqlStat.append(" AND tests.ser_no IN (SELECT ser_no FROM items WHERE locn_name='Oxford')");
       sqlStat.append(" AND tests.TEST_no = "+SCTDBInfo.sctdaqDBTableNames[testIndex]+".TEST_no");
       sqlStat.append(" AND SCT_TSTDAQINFO.version NOT LIKE 'SctRodDaq%' AND SCT_TSTDAQINFO.test_no=tests.TEST_no");  // SCTDAQ data only
       if(isWarm) sqlStat.append(" AND sct_tstdcsinfo.t0>10 AND sct_tstdcsinfo.TEST_no=tests.TEST_no");
       else  sqlStat.append(" AND sct_tstdcsinfo.t0<=10 AND sct_tstdcsinfo.TEST_no=tests.TEST_no");
       sqlStat.append(" ORDER BY tests.ser_no,tests.TEST_date DESC,tests.TEST_no DESC");
       
       BufferedWriter out = null;
       File oFile = new File(targetDir,SCTDBInfo.sctdaqDBTestNames[testIndex]+"_Reference.txt");

       Statement statement = SCTDBInterface.getInstance().connection.createStatement();
       System.out.println(sqlStat.toString());
       ResultSet resultSet = statement.executeQuery(sqlStat.toString());
       for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
            int rc=1;
	    
	    String sn = resultSet.getString(rc++);
	    if(s.contains(sn)) continue;
	    s.add(sn);

	    StringBuffer theLine = new StringBuffer("SN="+sn);
            theLine.append("TESTNO="+resultSet.getString(rc++));
	    System.out.println("sn="+sn+", location="+resultSet.getString(rc++)+" date="+guiUtilities.DaveUtils.extractDate(resultSet.getString(rc++)));
            theLine.append("DATA=");
            for(int j=0;j<12;j++) {
	      if(j>0) theLine.append(";");
              theLine.append(resultSet.getString(rc++));
	      theLine.append("*");
	      theLine.append(resultSet.getString(rc++));
	      }
	    if(out==null) out = new BufferedWriter(new FileWriter(oFile));
	    out.write(theLine.toString());
	    out.newLine();
	    }
         if(out!=null) out.close();
	 statement.close();
	 }



}